# UR Control

## Requirements

Python 3.10 needed. See python wheels support matrix for ur_rtde https://pypi.org/project/ur-rtde/
Virtualenv recommended. Install modules with `pip install -r requirements.txt`

URCap for Network control on Polyscope. Download: https://github.com/UniversalRobots/Universal_Robots_ExternalControl_URCap/releases
Tested with Version 1.0.5 on Polyscope 5.16.0
Installation Instructions: https://github.com/UniversalRobots/Universal_Robots_ROS_Driver/blob/master/ur_robot_driver/doc/install_urcap_e_series.md

### Install URCap in Simulator
URSim 5.16.0 inside VirtualBox.
Transfer donwloaded URCap via USB Thumbdrive to Programs UR10 folder on the virtual machine.
If error verr_pdm_no_usb_ports appreas, change USB Controller in VBox settings to USB-3.0-Controller (xHCI)

If resolution is too low, change it with `xrandr -s 1440x900`

To be able to reach the VM via network, set adapter to Bridge and promicious mode to allow all.

Follow instructions on how to setup externalControl: https://github.com/UniversalRobots/Universal_Robots_ROS_Driver/blob/master/ur_robot_driver/doc/install_urcap_e_series.md

Enable Remote Control: Settings - System - Remote Control - Enable
Run Program with the externalControl once. Error "Receive program failed" occurs. Stop Program. Not sure if this is needed, but RTDEControlInterface was not able to connect otherwise.
In main menu change from "local" to "remote control" in the top right corner.

## Misc

RTDEReceive works without enabling remote control.